// /Copyright 2003-2005 Arthur van Hoff, Rick Blair
// Licensed under Apache License version 2.0
// Original license LGPL

package javax.jmdns.impl;

import com.netgear.avcontroller.discovery.boujour.BonjourListener;
 import com.netgear.avcontroller.utils.InteAddressUtil;
import org.noear.solon.annotation.Component;
import org.noear.solon.annotation.Inject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jmdns.ServiceInfo;
import javax.jmdns.impl.constants.DNSRecordType;
import java.io.IOException;
@Component
public class HxJmDNSImpl  {
    private static Logger logger = LoggerFactory.getLogger(JmDNSImpl.class.getName());
    @Inject
    private BonjourListener listener;

    public HxJmDNSImpl(){

    }

    public     void handleResponse(DNSIncoming msg) throws IOException {
//        logger.info("handleResponse..........");
        String types="";
        if (msg._answers!=null || msg._additionals!=null){
            DNSRecord.Service srv=null;
            DNSRecord.IPv4Address address =null;
            if (msg._answers!=null) {
                for (DNSRecord additional : msg._answers) {
                    types += additional.getRecordType() + ":";
                    if (additional.getRecordType() == DNSRecordType.TYPE_SRV) {
                        srv = (DNSRecord.Service) additional;
                    }
                    if (additional.getRecordType() == DNSRecordType.TYPE_A) {
                        address = (DNSRecord.IPv4Address) additional;
                    }
                }
            }
            if ( msg._additionals!=null) {
                for (DNSRecord additional : msg._additionals) {
                    types += additional.getRecordType() + ":";
                    if (additional.getRecordType() == DNSRecordType.TYPE_SRV) {
                        srv = (DNSRecord.Service) additional;
                    }
                    if (additional.getRecordType() == DNSRecordType.TYPE_A) {
                        address = (DNSRecord.IPv4Address) additional;
                    }
                }
            }
//            String srvname="";
//            String aaaaadress="";
//            if (srv!=null){
//              srvname=srv.getName();
//            }
//            if (address!=null){
//                aaaaadress=address._addr.getHostAddress()  +"," +address.toString();
//            }
             if (srv!=null) {
                if (address!=null) {
                    HxService hxsrv=null;
                    if (address._addr.isReachable(1000) ){
                        hxsrv= new HxService(srv, address._addr.getHostAddress());
                    }else{
                        hxsrv= new HxService(srv, null);
                    }

                    handleRecord(hxsrv);
                }
            }
        }
    }



   private     void handleRecord(DNSRecord record) {

        if (InteAddressUtil.isMyIp(record.getRecordSource())){
//            logger.info("handleRecord  from {},{} ,skip",record.getRecordSource().getHostAddress(), InteAddressUtil.isMyIp(record.getRecordSource()));
            return;
        }
        // notify the listeners
        record.setTTL(10);
//            this.updateRecord(now, record, Operation.Add);
        if (DNSRecordType.TYPE_PTR.equals(record.getRecordType())
                || ( DNSRecordType.TYPE_SRV.equals(record.getRecordType()))){

            ServiceInfo event = record.getServiceInfo(false);
            ( (ServiceInfoImpl) event).setServer(((HxService)record).address);
            listener.serviceAdded(event);
        }
    }

}
